
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_MOSI   9
#define OLED_CLK   10
#define OLED_DC    11
#define OLED_CS    12
#define OLED_RESET 13
Adafruit_SSD1306 display(OLED_MOSI, OLED_CLK, OLED_DC, OLED_RESET, OLED_CS);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2
#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 
static const unsigned char PROGMEM logo16_glcd_bmp[] =
{ B00000000,B01110000,B00000000,B00000000,B00000000,B00000000,B01111100,B00000000,
B00000000,B00000000,B00000000,B00111111,B00000000,B00000000,B00000000,B00000000,
B00111111,B10000000,B00000000,B00000000,B00000000,B00011111,B11000000,B00000000,
B00000000,B00000000,B00011111,B11100000,B00000000,B00000000,B00000011,B11001111,
B11110000,B01111110,B00000000,B00000001,B11100111,B11110001,B11111110,B00000000,
B00000000,B11110111,B11111011,B11111100,B00000000,B11111100,B11111111,B11111111,
B11111000,B00000000,B11111110,B11111111,B11111111,B11110000,B00000000,B01111111,
B11111111,B11111111,B11110001,B11111000,B00111111,B11111111,B11111111,B11111111,
B11110000,B00111111,B11111111,B11111111,B11111111,B11100000,B00011111,B11111111,
B11111111,B11111111,B11100000,B00011111,B11111111,B11111111,B11111111,B11100000,
};
  
#define laser 3
#define switch1 4
#define LED1 2
#define relay 7
String message;


void setup() {
  Serial.begin(9600);
   pinMode(laser, OUTPUT);
   pinMode(LED1, OUTPUT);
   pinMode(relay, OUTPUT);
   digitalWrite(relay,HIGH);

   
   

   screensetup();
   
   message= "Initialized. Push button to begin";
   screenmessage(message);
   
   
   analogWrite(laser,3.2);
   
  
}

void loop() {
  // put your main code here, to run repeatedly:
 
  //float light = readlaser();
  Serial.print(" Luminosity = ");
   Serial.println(analogRead(A0));
  
  int switchon =digitalRead(switch1);

  if(switchon==1){
    beginmonitor();
   }
  
 
  delay(100);
   
  

}

float readlaser(){
  int i=0;
  double total=0;
  for(i=0;i<100;i++){
    total=total+analogRead(A0)/100.0;
    delay(50);
  }

  return total;
}

void screensetup(){
  display.begin(SSD1306_SWITCHCAPVCC);  // Switch OLED
  display.clearDisplay();  // Clear OLED

  //Do the sydney Logo
  display.drawBitmap(91, 1,  logo16_glcd_bmp, 40,16, 1);
  display.display();

  
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0,2);
  display.println("iGEM");
  
  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(52,0);
  display.println("Sydney");
  
  
    display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(58,10);
  display.println("2015");
  
  display.drawLine(0,19,128,19,WHITE);

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(1,21);
  display.println("Status:");
  
  display.display();

// display.startscrolldiagright(0x00, 0x07);
  
}
void screenmessage(String message){
  display.fillRect(0, 30, 128, 19, BLACK);
  display.display();
  
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(1,31);
  display.println(message);
  display.display();
  
}


  void beginmonitor(){
    message= "Calibrating light sensor";
    screenmessage(message);
    digitalWrite(relay,LOW);
   

    
    delay(5000);

    //Do threshold measurement
    double LightThreshold = readlaser();
   // Serial.print("Calibration Luminosity = ");
  //  Serial.println(LightThreshold);

    
    message= "Monitoring in progress";
    screenmessage(message);
    boolean flag = true;
    double light=0;
    while(flag){
     light = readlaser();

      if(light<LightThreshold-200.0){
        reachedend();
        flag=false;
      }
  
    }
  
  }

void reachedend(){
  
  digitalWrite(relay,HIGH);
  analogWrite(laser,0.0);
  //Here you need to flip the High voltage switch

  message= "Finished!!! Hold button to end";
  
  screenmessage(message);
  int switchon =0;
  while(switchon==0){
    
    digitalWrite(LED1,HIGH);
    tone(6,2200,100);
   
    delay(700);
    digitalWrite(LED1,LOW);
    
    delay(700);
    switchon =digitalRead(switch1);
  }

  digitalWrite(LED1,LOW);
  
  
  message= "Ended";
  screenmessage(message);
  
  delay(5000);
  message= "Initialized. Push button to begin";
  screenmessage(message);
  analogWrite(laser,3.2);

}
